unit Course;

interface

uses objload, Polygon, Materials, Matrices, SySUtils, Windows, Messages, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, GL, Textures, NewtonImport, game;

type tCourse = class
  published
    constructor Create(name : string; wallT : cardinal; roadT : cardinal);
    destructor Destroy;
    procedure draw;
    function getCollTree : PNewtonCollision;
  private Mesh, aspMesh : tMesh;
          wall, asphalt : tTexturedMaterial;
          mat : Matrix;
end;

  result = array[1..50,1..50] of short;

implementation

    constructor tCourse.Create(name : string; wallT : cardinal; roadT : cardinal);
    var BufferMesh : array[1..11] of tMesh;
        meta : tMesh;
        f : file of result;
        r : result;
        i, j, k : cardinal;
        firstvert : cardinal;
        firsttextcoord, firstface : cardinal;
        zmod, xmod : GLFloat;
    //Kis fggvny egy Mesh klnozsra-----------------------------------------
    function cloneMesh(mesh : tMesh) : tMesh;
    var buffer : tMesh;
        i : cardinal;
    begin
      buffer.fnum:=mesh.fnum;
      setLength(buffer.faces,length(mesh.faces));
      setLength(buffer.vertices,length(mesh.vertices));
      setLength(buffer.textcoords,length(mesh.textcoords));

      for i:=low(mesh.vertices) to high(mesh.vertices) do begin
        buffer.vertices[i]:=mesh.vertices[i];
      end;

      for i:=low(mesh.textcoords) to high(mesh.textcoords) do begin
        buffer.textcoords[i]:=mesh.textcoords[i];
      end;

      for i:=low(mesh.faces) to high(mesh.faces) do begin
        buffer.faces[i]:=mesh.faces[i];
      end;

      cloneMesh:=buffer;
    end;
    //--------------------------------------------------------------------------
    begin
      wall:=tTexturedMaterial.Create;
      wall.setTexture(wallT);
      asphalt:=tTexturedMaterial.Create;
      asphalt.setTexture(roadT);
      mat:=Matrix.Create;
      mat.makeIdentity;
      aspMesh:=loadObjFile('track/common/asphalt.obj');
      BufferMesh[1]:=loadObjFile('track/common/horizontal.obj');
      BufferMesh[2]:=loadObjFile('track/common/vertical.obj');
      BufferMesh[3]:=loadObjFile('track/common/upleft.obj');
      BufferMesh[4]:=loadObjFile('track/common/upright.obj');
      BufferMesh[5]:=loadObjFile('track/common/downleft.obj');
      BufferMesh[6]:=loadObjFile('track/common/downright.obj');
      BufferMesh[7]:=loadObjFile('track/common/tleft.obj');
      BufferMesh[8]:=loadObjFile('track/common/tup.obj');
      BufferMesh[9]:=loadObjFile('track/common/tright.obj');
      BufferMesh[10]:=loadObjFile('track/common/tdown.obj');
      BufferMesh[11]:=loadObjFile('track/common/cross.obj');
      //A plya beolvassa
      assignFile(f,'track/'+name);
      reset(f);
      read(f,r);
      closeFile(f);
      //Egy darab Mesh ptse az adatokbl
      setLength(Mesh.vertices,0);
      setLength(Mesh.textcoords,0);
      setLength(Mesh.faces,0);
      for i:=0 to 49 do begin
        for j:=0 to 49 do begin
          if (r[i+1,j+1]>1) then begin
            //Aktulis elem bersa a nagy falba--------------------------------------
            meta:=cloneMesh(BufferMesh[r[i+1,j+1]-1]);
            zmod:=-125.0+((1.0*i)*5.0);
            xmod:=-125.0+((1.0*j)*5.0);
            //Elem vertexeinek s textcoordjainak bemsolsa
            firstvert:=high(mesh.vertices)+1;
            firsttextcoord:=high(mesh.textcoords)+1;
            firstface:=high(mesh.faces)+1;
            setLength(mesh.vertices,length(mesh.vertices)+length(meta.vertices));
            setLength(mesh.textcoords,length(mesh.textcoords)+length(meta.textcoords));
            setLength(mesh.faces,length(mesh.faces)+length(meta.faces));
            //Vertex coordintk mdostsa, tmsolsa
            for k:=low(meta.vertices) to high(meta.vertices) do begin
              meta.vertices[k].x:=meta.vertices[k].x+xmod;
              meta.vertices[k].z:=meta.vertices[k].z+zmod;
              meta.vertices[k].y:=meta.vertices[k].y-1.0;
              mesh.vertices[firstvert+k]:=meta.vertices[k];
            end;
            //Textcoord-ok bemsolsa
            for k:=low(meta.textcoords) to high(meta.textcoords) do begin
              mesh.textcoords[firsttextcoord+k]:=meta.textcoords[k];
            end;
            //Face-k bemsolsa
            for k:=low(meta.faces) to high(meta.faces) do begin
              //Face indexeinek mdostsa
              meta.faces[k].v1:=meta.faces[k].v1+firstvert;
              meta.faces[k].v2:=meta.faces[k].v2+firstvert;
              meta.faces[k].v3:=meta.faces[k].v3+firstvert;
              if (meta.faces[k].vnum=4) then
                    meta.faces[k].v4:=meta.faces[k].v4+firstvert;

              meta.faces[k].t1:=meta.faces[k].t1+firsttextcoord;
              meta.faces[k].t2:=meta.faces[k].t2+firsttextcoord;
              meta.faces[k].t3:=meta.faces[k].t3+firsttextcoord;
              if (meta.faces[k].vnum=4) then
                    meta.faces[k].t4:=meta.faces[k].t4+firsttextcoord;
              //Bemsols
              mesh.faces[firstface+k]:=meta.faces[k];
            end;
            //------------------------------------------------------------------------
            end;
          end;
        end;
        for i:=1 to 11 do begin
          cleanMesh(BufferMesh[i]);
        end;
      end;

      function tCourse.getCollTree : PNewtonCollision;
      var buff : PNewtonCollision;
          tmpFace : array[0..3] of tVertex;
          i : cardinal;
      begin
        buff := NewtonCreateTreeCollision(NewtonWorld, nil);
        NewtonTreeCollisionBeginBuild(buff);
        //Elszr a falak hozzadsa--------------------------------------------
        //----------------------------------------------------------------------
        for i:=low(mesh.faces) to high(mesh.faces) do begin
          tmpFace[0]:=mesh.vertices[mesh.faces[i].v1];
          tmpFace[1]:=mesh.vertices[mesh.faces[i].v2];
          tmpFace[2]:=mesh.vertices[mesh.faces[i].v3];
          if mesh.faces[i].vnum=4 then
              tmpFace[3]:=mesh.vertices[mesh.faces[i].v4];
          NewtonTreeCollisionAddFace(buff, mesh.faces[i].vnum, @tmpFace[0], SizeOf(tVertex), 1);
        end;
        //Majd a fld----------------------------------------------------------
        for i:=low(aspMesh.faces) to high(aspMesh.faces) do begin
          tmpFace[0]:=aspMesh.vertices[aspMesh.faces[i].v1];
          tmpFace[1]:=aspMesh.vertices[aspMesh.faces[i].v2];
          tmpFace[2]:=aspMesh.vertices[aspMesh.faces[i].v3];
          if aspMesh.faces[i].vnum=4 then
              tmpFace[3]:=aspMesh.vertices[aspMesh.faces[i].v4];
          NewtonTreeCollisionAddFace(buff, aspMesh.faces[i].vnum, @tmpFace[0], SizeOf(tVertex), 1);
        end;
        //----------------------------------------------------------------------
        NewtonTreeCollisionEndBuild(buff,0);
        getCollTree:=buff;
      end;

      procedure tCourse.draw;
      begin
        mat.useThis;
        wall.draw(Mesh);
        asphalt.draw(aspMesh);
      end;

      destructor tCourse.Destroy;
      begin
        wall.Destroy;
        asphalt.Destroy;
        cleanMesh(mesh);
        cleanMesh(aspMesh);
        mat.Destroy;
      end;

end.
