unit Materials;

interface

uses Polygon, SDL, GL, GLU;

type
    tBaseMaterial = class
    published
          procedure draw(mesh : tMesh); virtual;
    end;

    tTexturedMaterial = class(tBaseMaterial)
    published
          destructor Destroy;
          procedure draw(mesh : tMesh); virtual;
          procedure setTexture(textIn : cardinal);
    private
          texture : cardinal;
    end;

implementation

procedure tTexturedMaterial.setTexture(textIn : cardinal);
begin
  texture:=textIn;
end;

destructor tTexturedMaterial.Destroy;
begin
  glDeleteTextures(1,@texture);
  inherited;
end;

procedure tBaseMaterial.draw(mesh : tMesh);
var i, j : integer;
begin
    glDisable(GL_TEXTURE_2D);
    for i:=low(mesh.faces) to high(mesh.faces) do begin
    glBegin(GL_POLYGON);
            glVertex3fv(@mesh.vertices[mesh.faces[i].v1]);
            glVertex3fv(@mesh.vertices[mesh.faces[i].v2]);
            glVertex3fv(@mesh.vertices[mesh.faces[i].v3]);
            if mesh.faces[i].vnum=4 then begin
                glVertex3fv(@mesh.vertices[mesh.faces[i].v4]);
            end;
    glEnd;
    end;
end;

procedure tTexturedMaterial.draw(mesh : tMesh);
var i, j : integer;
begin
    glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D,texture);
    for i:=low(mesh.faces) to high(mesh.faces) do begin
    glBegin(GL_POLYGON);
            glTexCoord2fv(@mesh.textcoords[mesh.faces[i].t1]);
            glVertex3fv(@mesh.vertices[mesh.faces[i].v1]);
            glTexCoord2fv(@mesh.textcoords[mesh.faces[i].t2]);
            glVertex3fv(@mesh.vertices[mesh.faces[i].v2]);
            glTexCoord2fv(@mesh.textcoords[mesh.faces[i].t3]);
            glVertex3fv(@mesh.vertices[mesh.faces[i].v3]);
            if mesh.faces[i].vnum=4 then begin
                glTexCoord2fv(@mesh.textcoords[mesh.faces[i].t4]);
                glVertex3fv(@mesh.vertices[mesh.faces[i].v4]);
            end;
    glEnd;
    end;
end;

end.
