unit Polygon;

interface

uses GL;

type
    tVertex = packed record
            x,y,z : glFloat;
    end;

    tTextCoord = record
            u,v : glFloat;
    end;

    tPolygon = record
            v1, v2, v3, v4 : glUInt;
            t1, t2, t3, t4 : glUInt;
            vnum : glShort;
    end;

    tMesh = record
            fnum : glUInt;
            faces : array of tPolygon;
            vertices : array of tVertex;
            textcoords : array of tTextCoord;
    end;

procedure cleanMesh(mesh : tMesh);

implementation

procedure cleanMesh(mesh : tMesh);
begin
  Finalize(mesh.faces);
  Finalize(mesh.vertices);
  Finalize(mesh.textcoords);
end;

end.
 