unit Track;

interface

uses Polygon, GL, GLU;

type tTrack = class
published
    procedure load;
    procedure draw;
    destructor Destroy;
private mesh : tMesh;
        num : integer;
        sections : array of integer;
end;
implementation

procedure tTrack.load;
var size : GLFloat;     //IDEIGLENES
    i, j, k, actual : integer;
    grid, segnum : GLFloat;
begin
    //Belltunk pr tetszleges rtket (ideiglenes)
    num:=256;
    size:=1024;
    grid:=size/(1.0*num-1.0);
    //Ltrehozzuk a megfelel vertexeket
    setLength(mesh.vertices,num*num);
    for i:=0 to num-1 do begin
        for j:=0 to num-1 do begin
            actual:=i*num+j;
            mesh.vertices[actual].x:=(-size/2.0)+(j*grid);
            mesh.vertices[actual].y:=-1.0;
            mesh.vertices[actual].z:=(-size/2.0)+(i*grid);
        end;
    end;
    //Ltrehozzuk a szegmenseket
end;

procedure tTrack.draw;
var i,j, actual : integer;
    viewx,viewz : integer;
begin
    viewx:=128;
    viewz:=128;

    for i:=viewz-64 to viewz+63 do begin
        for j:=viewx-64 to viewx+63 do begin
            actual:=i*num+j;
            if ((actual >=0) and (actual < (num*num-1))) then begin
              glBegin(GL_POLYGON);
                glTexCoord2f(0.0,0.0);
                glVertex3fv(@mesh.vertices[actual]);
                glTexCoord2f(1.0,0.0);
                glVertex3fv(@mesh.vertices[actual+num]);
                glTexCoord2f(0.0,1.0);
                glVertex3fv(@mesh.vertices[actual+1]);
              glEnd;
              glBegin(GL_POLYGON);
                glTexCoord2f(0.0,1.0);
                glVertex3fv(@mesh.vertices[actual+1]);
                glTexCoord2f(1.0,0.0);
                glVertex3fv(@mesh.vertices[actual+num]);
                glTexCoord2f(1.0,1.0);
                glVertex3fv(@mesh.vertices[actual+num+1]);
              glEnd;
            end;
        end;
    end;

end;

destructor tTrack.Destroy;
begin
  freeMem(mesh.faces);
  freeMem(mesh.vertices);
  freeMem(mesh.textcoords);
end;

end.
