unit game;

interface

uses NewtonImport;

type controls = record
   Accelerate, Brake, SteerLeft, SteerRight, GearUp, GearDown, Handbrake, Bigturn : boolean;
end;

var NewtonWorld   : PNewtonWorld;
    carctr : controls;
function startGame(carName, trackName : string) : cardinal;

implementation

uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, SDL, GL, GLU, objload, Polygon, Matrices, Materials, Textures, Car,
  Course;

var screen:pSDL_SURFACE;
    event : pSDL_EVENT;
    cName, tName : string;
    car : tCar;
    track : tCourse;
    //Fizika idztse
    AccTimeSlice  : Single;
    TimeLastFrame : Cardinal;
    //Fizika
    NewtonBodies    : array of PNewtonBody;
    vehJoint : PNewtonJoint;

//Fizikai motort kezel fggvnyek----------------------------------------------
procedure ForceAndTorqueCallback(const body : PNewtonBody); cdecl;
var
 Mass    : Single;
 Inertia : V3;
 Force   : V3;
begin
  NewtonBodyGetMassMatrix(Body, @Mass, @Inertia[0], @Inertia[1], @Inertia[2]);
  Force := vec3(0, -9.8 * Mass, 0);
  NewtonBodyAddForce(Body, @Force[0]);
end;
//------------------------------------------------------------------------------

function esemenyKezel : boolean;
begin
  esemenyKezel:=false;
  if SDL_POLLEVENT(event)=1 then
  begin
    case event^.type_ of
      SDL_KEYDOWN: begin
        if event^.key.keysym.sym = SDLK_ESCAPE then esemenyKezel:=true;
        if event^.key.keysym.sym = SDLK_UP then carctr.Accelerate:=true;
        if event^.key.keysym.sym = SDLK_DOWN then carctr.Brake:=true;
        if event^.key.keysym.sym = SDLK_LEFT then carctr.SteerLeft:=true;
        if event^.key.keysym.sym = SDLK_RIGHT then carctr.SteerRight:=true;
        if event^.key.keysym.sym = SDLK_SPACE then carctr.Handbrake:=true;
        if event^.key.keysym.sym = SDLK_a then carctr.GearUp:=true;
        if event^.key.keysym.sym = SDLK_r then carctr.GearDown:=true;
        if event^.key.keysym.sym = SDLK_q then carctr.Bigturn:=true;
      end;
      SDL_KEYUP: begin
        if event^.key.keysym.sym = SDLK_UP then carctr.Accelerate:=false;
        if event^.key.keysym.sym = SDLK_DOWN then carctr.Brake:=false;
        if event^.key.keysym.sym = SDLK_LEFT then carctr.SteerLeft:=false;
        if event^.key.keysym.sym = SDLK_RIGHT then carctr.SteerRight:=false;
        if event^.key.keysym.sym = SDLK_SPACE then carctr.Handbrake:=false;
        if event^.key.keysym.sym = SDLK_r then carctr.GearDown:=false;
        if event^.key.keysym.sym = SDLK_q then carctr.Bigturn:=false;
      end;
      SDL_QUITEV: esemenyKezel:=true;
    end;
  end;
end;

procedure setUpBoxes;
var Inertia, min, max, up   : V3;
    Collision : PNewtonCollision;
    temp : Matrix;
    Matrixx : M4;
begin
    //Plya---------------------------------------------------------------------
    temp:=Matrix.Create;
    temp.makeIdentity;
    Collision:=track.getCollTree;
    setLength(NewtonBodies,2);
    NewtonBodies[0]:=NewtonCreateBody(NewtonWorld, Collision);
    NewtonBodySetMassMatrix(NewtonBodies[0], 0, 1, 1, 1);
    Matrixx:=temp.getData;
    NewtonBodySetMatrix(NewtonBodies[0], @Matrixx[0,0]);
    NewtonBodySetForceAndTorqueCallBack(NewtonBodies[0], ForceAndTorqueCallBack);
    NewtonCollisionCalculateAABB(Collision, @Matrixx[0,0], @Min[0], @Max[0]);
    Min[1]:=Min[1]-10.0;
    Max[1]:=Max[1]+10.0;
    NewtonSetWorldSize(NewtonWorld, @Min[0], @Max[0]);
    NewtonReleaseCollision(NewtonWorld, Collision);
    //--------------------------------------------------------------------------
end;

procedure loadContent;
var mesh : tMesh;
    matr : Matrix;
    material : tTexturedMaterial;
    num, wallT, roadT  : cardinal;
    dir : string;
    tmp : M4;
begin
  matr:=Matrix.Create;
  matr.makeIdentity;
  matr.translate(1.0,1.0,0);
  dir:=getCurrentDir;
  //num:=1;
  //wallT:=2;
  //roadT:=3;
  //loadTexture(dir+'/cars/'+cName+'/cartext.tga',num,false);
  loadTexture(dir+'/track/common/wall.tga',wallT,false);
  loadTexture(dir+'/track/common/asphalt.tga',roadT,false);
  //mesh:=loadObjFile('cars/'+cName+'/car.obj');
  //material:=tTexturedMaterial.Create;
  //material.setTexture(num);
  tmp:=matr.getData;
  car:=tCar.Create(tmp, cName);
  track:=tCourse.Create(tName,wallT,roadT);

  setUpBoxes;
end;

procedure renderStuff;
var MatBuf : M4;
begin
  //NewtonBodyGetMatrix(NewtonBodies[1], @MatBuf[0,0]);
  //car.setMat(MatBuf);
  car.draw;
  track.draw;
end;

procedure renderSystem;
var tmpMat : M4;
    camPos, tmpVec : V3;
begin
  //Idmrs
  AccTimeSlice  := AccTimeSlice + (SDL_GetTicks-TimeLastFrame);
  TimeLastFrame := SDL_GetTicks;

  glCLEAR(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glColor3f(1.0,1.0,1.0);
  //Kamerakezels
  NewtonBodyGetMatrix(car.Body,@tmpMat[0,0]);
  camPos:=Vec3(8.0,4.0,0.0);
  tmpVec:=multiplyMatrixWithVec(tmpMat,camPos);

  glMATRIXMODE(GL_PROJECTION);
  glLoadIdentity;
  gluPERSPECTIVE(45.0, 640.0/480.0, 0.01, 1000.0);
  //gluLookAt(tmpMat[3,0]+5.0,tmpMat[3,1]+10.0,tmpMat[3,2]+5.0,tmpMat[3,0],tmpMat[3,1],tmpMat[3,2],0.0,1.0,0.0);
  gluLookAt(tmpVec[0],tmpVec[1],tmpVec[2],tmpMat[3,0],tmpMat[3,1],tmpMat[3,2],0.0,1.0,0.0);
  glMATRIXMODE(GL_MODELVIEW);
  //Rajzols
  renderStuff;
  SDL_GL_SWAPBUFFERS;

  while AccTimeSlice > 12 do
  begin
    NewtonUpdate(NewtonWorld, (12 / 1000));
    AccTimeSlice := AccTimeSlice - 12;
  end;
end;

function startGame(carName, trackName : string) : cardinal;
var kilep : boolean;
    finishPos : V3;
    carPos : M4;
    startTime : cardinal;
begin
  cName := carName;
  tName := trackName;
  carctr.Accelerate:=false;
  carctr.Brake:=false;
  carctr.SteerLeft:=false;
  carctr.SteerRight:=false;
  carctr.GearUp:=false;
  carctr.GearDown:=false;
  carctr.Handbrake:=false;

  finishPos:=Vec3(-125.0,-125.0,0.0);


  SDL_INIT(SDL_INIT_VIDEO or SDL_INIT_AUDIO);

  SDL_GL_SETATTRIBUTE(SDL_GL_RED_SIZE, 5);
  SDL_GL_SETATTRIBUTE(SDL_GL_GREEN_SIZE, 5);
  SDL_GL_SETATTRIBUTE(SDL_GL_BLUE_SIZE, 5);
  SDL_GL_SETATTRIBUTE(SDL_GL_DEPTH_SIZE, 16);
  SDL_GL_SETATTRIBUTE(SDL_GL_DOUBLEBUFFER, 1);

  screen:=SDL_SETVIDEOMODE(1024, 768, 0, SDL_OPENGL);
  IF screen=NIL THEN HALT;

  new(event);

  SDL_WM_SETCAPTION(PChar('Szlalom'),nil);

  glCLEARCOLOR(0.0, 0.5, 1.0, 0.0);
  glVIEWPORT(0,0,1024,768);
  glMATRIXMODE(GL_PROJECTION);
  glLOADIDENTITY;
  gluPERSPECTIVE(45.0, 640.0/480.0, 0.01, 1000.0);
  gluLookAt(5.0,10.0,5.0,0.0,0.0,0.0,0.0,1.0,0.0);
  glMATRIXMODE(GL_MODELVIEW);
  glENABLE(GL_CULL_FACE);
  glCULLFACE(GL_BACK);
  glClearDepth(1.0);
  glEnable(GL_DEPTH_TEST);
  glDepthFunc(GL_LEQUAL);
  glCLEAR(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

  //Fizika
  NewtonWorld := NewtonCreate(nil, nil);
  NewtonSetMinimumFrameRate(NewtonWorld, 150);
  //NewtonSetSolverModel(NewtonWorld,1);
  //NewtonSetFrictionModel(NewtonWorld,1);

  loadContent;

  accTimeSlice:=0;
  TimeLastFrame:=SDL_GetTicks;

  startTime:=SDL_GetTicks;

  repeat
    kilep:=esemenyKezel;
    //Clba rnk?
    NewtonBodyGetMatrix(car.Body,@carPos[0,0]);
    if kilep = true then
      startGame:=0;
    SDL_WM_SETCAPTION(PChar(IntToStr(SDL_GetTicks-startTime)),nil);
    if sqrt(sqr(finishPos[0]-carPos[3,0])+sqr(finishPos[0]-carPos[3,2]))<10.0 then begin
      kilep:=true;
      startGame:=SDL_GetTicks-startTime;
    end;
    //Rajzolunk
    renderSystem;
  until kilep;

  glCLEAR(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  SDL_GL_SWAPBUFFERS;
  newtonDestroyAllBodies(newtonWorld);
  newtonDestroy(newtonWorld);
  dispose(event);
  track.Destroy;
  car.Destroy;
end;

end.
