unit objload;

interface
uses Polygon, SySUtils, Windows, Messages, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

function loadObjFile(fileName : string) : tMesh;

implementation
procedure Split(const Delimiter: Char;Input: string;const Strings: TStrings);
begin
   Assert(Assigned(Strings)) ;
   Strings.Clear;
   Strings.Delimiter := Delimiter;
   Strings.DelimitedText := Input;
end;
//Vertexet tartalmaz sort feldolgoz fv.---------------------------------------
procedure processVerex(vert : string; mesh : tMesh);
var A : TStringList;
begin
    A:=TStringList.Create;
    Split(' ',vert,A);
    writeln(IntToStr(length(mesh.vertices)));
    setLength(mesh.vertices,(length(mesh.vertices)+1));
    writeln(IntToStr(length(mesh.vertices)));
    mesh.vertices[length(mesh.vertices)-1].x:=StrToFloat(A[1]);
    mesh.vertices[length(mesh.vertices)-1].y:=StrToFloat(A[2]);
    mesh.vertices[length(mesh.vertices)-1].z:=StrToFloat(A[3]);
    write('n: ',IntToStr(length(mesh.vertices)-1),' ');
    write('X:',FloatToStr(mesh.vertices[length(mesh.vertices)-1].x),' ');
    write('Y:',FloatToStr(mesh.vertices[length(mesh.vertices)-1].y),' ');
    writeln('Z:',FloatToStr(mesh.vertices[length(mesh.vertices)-1].z),' ');
    A.Destroy;
end;
//------------------------------------------------------------------------------

//Faceket tartalmaz sor feldolgozsa-------------------------------------------
//Ideiglenesen csak vertex indexeket tartalmaz facek kezelse
procedure processFace(face : string;mesh : tMesh);
var A : TStringList;
begin
    A:=TStringList.Create;
    Split(' ',face,A);
    setLength(mesh.faces,length(mesh.faces)+1);
    mesh.faces[length(mesh.faces)-1].vnum:=4;
    mesh.faces[length(mesh.faces)-1].v1:=StrToInt(A[1]);
    mesh.faces[length(mesh.faces)-1].v2:=StrToInt(A[2]);
    mesh.faces[length(mesh.faces)-1].v3:=StrToInt(A[3]);
    mesh.faces[length(mesh.faces)-1].v4:=StrToInt(A[4]);
    A.Destroy;
end;
//------------------------------------------------------------------------------

function loadObjFile(fileName : string) : tMesh;
var objFile : TextFile;
    text : string;
    mesh : tMesh;
    i, num : integer;
    var A, B : TStringList;
begin
    AssignFile(objFile,fileName);
    Reset(objFile);
    setLength(mesh.vertices,0);
    setLength(mesh.textcoords,0);
    setLength(mesh.faces,0);
    DecimalSeparator:='.';
    //Fjl olvassa
    while not Eof(objFile) do begin
        //Beolvassuk a fjl adott sort-----------------------------------------
        readln(objFile, text);
        //Felbontjuk a szkzk mentn
        A:=TStringList.Create;
        B:=TStringList.Create;
        Split(' ',text,A);
        //Eldntjk, mit tartalmaz----------------------------------------------
        if text[1]='#' then begin //Komment, figyelmen kvl hagyjuk
        end
        else if A[0]='v' then begin //Ez egy vertex
                setLength(mesh.vertices,(length(mesh.vertices)+1));
                mesh.vertices[length(mesh.vertices)-1].x:=StrToFloat(A[1]);
                mesh.vertices[length(mesh.vertices)-1].y:=StrToFloat(A[2]);
                mesh.vertices[length(mesh.vertices)-1].z:=StrToFloat(A[3]);
        end
        else if A[0]='vt' then begin //Ez egy text-coord
                setLength(mesh.textcoords,(length(mesh.textcoords)+1));
                mesh.textcoords[length(mesh.textcoords)-1].u:=StrToFloat(A[1]);
                mesh.textcoords[length(mesh.textcoords)-1].v:=StrToFloat(A[2]);
        end
        else if A[0]='f' then begin  //Ez egy face
                setLength(mesh.faces,length(mesh.faces)+1);
                //Megadjuk a poligon elemeinek szmt (3 v 4)
                mesh.faces[length(mesh.faces)-1].vnum:=A.Count-1;
                Split('/',A[1],B);
                mesh.faces[length(mesh.faces)-1].v1:=StrToInt(B[0])-1;
                mesh.faces[length(mesh.faces)-1].t1:=StrToInt(B[1])-1;
                Split('/',A[2],B);
                mesh.faces[length(mesh.faces)-1].v2:=StrToInt(B[0])-1;
                mesh.faces[length(mesh.faces)-1].t2:=StrToInt(B[1])-1;
                Split('/',A[3],B);
                mesh.faces[length(mesh.faces)-1].v3:=StrToInt(B[0])-1;
                mesh.faces[length(mesh.faces)-1].t3:=StrToInt(B[1])-1;
                if mesh.faces[length(mesh.faces)-1].vnum=4 then begin
                  Split('/',A[4],B);
                  mesh.faces[length(mesh.faces)-1].v4:=StrToInt(B[0])-1;
                  mesh.faces[length(mesh.faces)-1].t4:=StrToInt(B[1])-1;
                end;
        end;
        A.Destroy;
        B.Destroy;
        //----------------------------------------------------------------------
    end;
    Close(objFile);
    loadObjFile:=mesh;
end;

end.
